#######
# listCSVToJSON.py
# description : convert a Gargantext list v3 into a list v4
# licence : AGPL + CECILL v3
# author : quentin lobbé - qlobbe@iscpif.fr
#######

import sys
import csv
import json

try :
    list_path = sys.argv[1]
except :
    print ("! args error\n")
    print ("try : python3 listCSVToJSON.py ./list.csv\n")
    sys.exit(0)


list_v4 = {
    'Authors' : {'version' : 14143, 'data' : {}},
    'Institutes' : {'version' : 14143, 'data' : {}},
    'Sources' : {'version' : 14143, 'data' : {}},
    'NgramsTerms' : {'version' : 14143, 'data' : {}}
}


# read a map list v3 as a Csv file
with open(list_path, newline='\n') as file :

    raw_data = csv.reader(file, delimiter='\t')
    next(raw_data, None)

    for row in raw_data :

        term = {}

        if row[0] == 'main' :
            term['list'] = 'CandidateTerm'
        elif row[0] == 'stop' :
            term['list'] = 'StopTerm'
        else :
            term['list'] = 'MapTerm'

        term['size'] = len(row[1].split(' '))

        if not row[2] :
            term['children'] = []
        else :
            term['children'] = row[2].split('|&|')

        list_v4['NgramsTerms']['data'][row[1]] = term



# write a map list v4 as a Json file
with open(list_path.split('.')[0] + '.json', 'w') as file :
   json.dump(list_v4, file, sort_keys=True, indent=4)
